config/routes.rb
Rails.application.routes.draw do

  
  resources :projects do
    resources :tickets do
      member do
        put :change
      end
      resources :timelogs
      resources :checkboxes do
        member do 
          patch :complete
        end 
      end
      resources :comments
    end
  end
  resources :lists do 
    resources :tasks do
      member do 
        put :change
        put :complete
      end
    end
  end 
  
  get 'pages/home'
  get 'about' => 'pages#about'
  get 'peoples' => 'pages#peoples'

  root 'projects#index'
  devise_for :users, :controllers => { registrations: 'registrations' }

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/project.rb
class Project < ApplicationRecord
	has_many :tickets, dependent: :destroy

  accepts_nested_attributes_for :tickets

end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :edit, :update, :destroy]
  before_action :set_tickets, only: [:show]
  # GET /projects
  # GET /projects.json
  def index
    @projects = Project.all
    @my_tickets = Ticket.where(user_id: current_user).all
  end

  # GET /projects/1
  # GET /projects/1.json
  def show
    @urgent = @project.tickets.where(priority: "urgent")
    @users = User.all
    @project_users ||= []
    @project.tickets.each do |ticket|
        @project_users << User.find(ticket.user_id)
    end 
    @project_users = @project_users.uniq
    
    @total_hours = 0
    @project.tickets.each do |ticket|
      @total_hours += ticket.timelogs.sum('spend_time')
    end
  end

  # GET /projects/new
  def new
    @project = Project.new
    @project.tickets.build
  end

  # GET /projects/1/edit
  def edit
  end

  # POST /projects
  # POST /projects.json
  def create
    @project = Project.new(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to @project, notice: 'Project was successfully created.' }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end 
  end

  # PATCH/PUT /projects/1
  # PATCH/PUT /projects/1.json
  def update
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to @project, notice: 'Project was successfully updated.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1
  # DELETE /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: 'Project was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def project_params
      params.require(:project).permit(:name, :description, :id)
    end

    def set_tickets
      @tickets = Project.find(params[:id]).tickets
    end
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/projects/_form.html.erb
<%= simple_form_for(@project) do |f| %>
  <%= f.error_notification %>

  <div class="form-inputs">
    <%= f.input :name %>
    <%= f.input :description %>
  </div>

  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %>

app/views/projects/_ticket.html.erb
<%= form_for [@project, ticket] do |f| %>
  <% if task.errors.any? %>
    <div class="alert alert-danger">
      <% task.errors.full_messages.each do |msg| %>
        <p><%= msg %></p>
      <% end %>
    </div>
  <% end %>

  <div class="form-group">
    <%= f.label :subject %>
    <%= f.text_field :subject, class: 'form-control' %>
  </div>


  <%= f.submit 'Save', class: 'btn btn-default' %>
<% end %>

app/views/projects/edit.html.erb
<h1>Editing Project</h1>

<%= render 'form', project: @project %>

<%= link_to 'Show', @project %> |
<%= link_to 'Back', projects_path %>

app/views/projects/index.html.erb
<p id="notice"><%= notice %></p>
<nav class="breadcrumb">
  <%= link_to "Home", root_path, class: "breadcrumb-item"%>
  <%= link_to "Projects", projects_path, class: "breadcrumb-item"%>
  <span class="breadcrumb-item active">All</span>
</nav>
<h2>My Tickets </h2>
        <table class="table table-bordered table-striped">
          <thead>
            <tr>
              <th>ID</th>
              <th>Subject</th>
              <th>State</th>
              <th>Priority</th>
              <th>Last Action</th>
              <th>Comments</th>
              <th>Time</th>
              <th colspan="5" ></th>
            </tr>
          </head>
          <tbody>
          <% @my_tickets.each_with_index do |ticket, index| %>
            <tr>
              <td>
              <%= ticket.id %>
                <% if ticket.checkboxes.try(:any?) %>
                &nbsp;<a href=""><i class='fa fa-hand-o-down' data-toggle="collapse" data-target="#checkboxes"<%=index.to_s%>"></i></a>
                <% end %>
              </td>
              <td><%=ticket.subject %></td>
              <td><%=ticket.state %></td>
              <td><%= ticket.priority %></td>
              <td>
                <% if ticket.comments.try(:any?) %>
                  <%= time_ago_in_words(ticket.comments.maximum('updated_at')) %>
                <% else %>
                  <%= time_ago_in_words(ticket.updated_at) %>
                <% end %>
              </td>
              <td><%= ticket.comments.count %></td>
              <td>
                <%= ticket.timelogs.sum(:spend_time)%> / 
                <%= ticket.estimated_hours %>
              </td>
              <% if ticket.state == "new" %>
              <td><%= link_to "<i class='fa fa-arrow-right'></i>".html_safe, change_project_ticket_path(ticket.project_id, ticket, state: "in progres" ), method: :put %></td> 
              <%else %>
              <td><%= link_to "<i class='fa fa-arrow-down'></i>".html_safe, change_project_ticket_path(ticket.project_id, ticket, state: "closed" ), method: :put %></td> 
              <% end %>
              <td><%= link_to "<i class='fa fa-clock-o'></i>".html_safe, new_project_ticket_timelog_path(ticket.project_id, ticket) %></td>
              <td><%= link_to "<i class='fa fa-eye'></i>".html_safe, project_ticket_path(ticket.project_id,ticket) %></td>
               
              <td><%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_ticket_path(ticket.project_id, ticket) %></td>
              <td><%= link_to "<i class='fa fa-times'></i>".html_safe, project_ticket_path(ticket.project_id,ticket), method: :delete, data: { confirm: 'Are you sure?' } %></td>
            </tr>
            <tr id="checkboxes"<%= index.to_s%>" class="collapse out">
              <td>
              </td>
              <td>
                <div>
                  <ol>
                    <% ticket.checkboxes.each do |c| %>
<% if c.completed_at? %>
            <div class="row">
              <div class="col-sm-3">
                <i class='fa fa-check-square-o'></i>
                <%= link_to "<i class='fa fa-times'></i>".html_safe, project_ticket_checkbox_path(ticket.project_id, ticket, c), method: :delete, data: { confirm: 'Are you sure?' } %>
              </div>              
              <div class="col-sm-9">
                <s><%= c.content %></s>
              </div>
              </div>

              <% else %>
            <div class="row">
              <div class="col-sm-3">
                <%= link_to "<i class='fa fa-square-o'></i>".html_safe, complete_project_ticket_checkbox_path(ticket.project_id,ticket, c), method: :patch %>
              </div>
              <div class="col-sm-9">
                <%= c.content %>
              </div>
              </div>
              <% end %>
                    <% end %>
                  </ol>
                </div>
              </td>
            </tr>
          <% end %>
          </tbody>
        </table>
<h2>All Projects <%= link_to "<i class='fa fa-plus-circle text-success'></i>".html_safe, new_project_path %></h2>

<table class="table ">
  <thead>
    <tr>
      <th>#</th>
      <th>Name</th>
      <th>Description</th>
      <th>Open Tickets</th>
      <th colspan="4"></th>
    </tr>
  </thead>

  <tbody>
    <% @projects.each do |project| %>
    <tr>
      <td><%= project.id %></td>
      <td><%= project.name %> </td>
      <td style="max-width: 300px;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;" > <%= project.description %> </td>
      <td> <%= project.tickets.where(state: "open").count %> </td>
      <td> <%= link_to "<i class='fa fa-eye'></i>".html_safe, project_path(project) %> </td>
      <td> <%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_path(project) %> </td> 
      <td> <%= link_to "<i class='fa fa-plus'></i>".html_safe, new_project_ticket_path(project) %> </td> 
      <td> <%= link_to "<i class='fa fa-times'></i>".html_safe, project, method: :delete, data: { confirm: 'Are you sure?' } %></td>
    </tr>    
    <% end %>
  </tbody>
</table>

<br>

app/views/projects/new.html.erb
<h1>New Project</h1>

<%= render 'form', project: @project %>

<%= link_to 'Back', projects_path %>

app/views/projects/show.html.erb
<p id="notice"><%= notice %></p>
<div class="container">
  <nav class="breadcrumb">
    <%= link_to "Home", root_path, class: "breadcrumb-item"%>
    <%= link_to "Projects", projects_path, class: "breadcrumb-item" %>
    <span class="breadcrumb-item active"> <%= @project.name %></span>
  </nav>
  <br>
  <div class="row">
    <div class="col btn-group">
      <button class="btn btn-secondary active"> <%= link_to 'Overview', @project %> </button>
      <button class="btn btn-secondary"><%= link_to 'Issues', project_tickets_path(@project) %></button>
      <button class="btn btn-secondary"><%= link_to 'New Issue', new_project_ticket_path(@project) %></button>
    </div>
  </div>
  <div class="row">
    <div class="col-5">
      <div class="card">
        <div class="card-header"><storng>Info</storng>
          <div class="btn-group pull-right">
          <%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_path(@project), class: "btn btn-secondary btn-sm" %>  
          <%= link_to "<i class='fa fa-times'></i>".html_safe, project_path(@project), method: :delete, data: {confirm: "Are you sure?" }, class: "btn btn-secondary btn-sm" %>  
          </div>
        </div>
        <div class="card-block">
          <dl class="row">
            <dt class="col-sm-3">Name</dt>
              <dd class="col-sm-9"><%= @project.name %></dd>
            <dt class="col-sm-3">Description</dt>
              <dd class="col-sm-9"> <%= @project.description %></dd>
          </dl>
        </div>
      </div>
    </div>
    <div class="col-5">
      <div class="card">
        <div class="card-header">Members</div>
        <div class="card-block"> 
        <% @project_users.each do |u| %>
          <%= link_to [u.name, u.last_name].join(" "), peoples_path %>,&nbsp;
        <% end %>
        </div>
      </div>
    </div>
  </div>
  <br>
  <div class="row">
    <div class="col-10">
      <div class="card">
        <div class="card-header">Project Statistics</div>
        <div class="card-block">
          <div class="row">
            <div class="col-6">
              <dl class="row">
                <dt class="col-sm-4">Last Activity</dt>
                  <dd class="col-sm-8"><%= time_ago_in_words(@project.tickets.maximum('updated_at'))%></dd>
                <dt class="col-sm-4">Issues Ratio</dt>
                  <dd class="col-sm-8"><%= @project.tickets.where(state: "In Progres").count %> / <%= @project.tickets.count %> </dd>
                <dt class="col-sm-4">Closed Issues</dt>
                  <dd class="col-sm-8"><%= @project.tickets.where(state: "Closed").count %></dd>  
              </dl>
            </div>
            <div class="col-6">
              <dl class="row">
                <dt class="col-sm-4">Total Hours</dt>
                  <dd class="col-sm-8"> <%= @total_hours %> </dd>
              </dl>
            </div>
          </div>
      </div>    
      </div>
    </div>
  </div>
  <br>
  <div class="row">
    <div class="col-10">
      <div class="card">
        <div class="card-header">Urgent tickets</div>
        <% if @urgent.try(:any?) %>
        <table class="table table-bordered table-striped">
          <thead>
            <tr>
              <th>ID</th>
              <th>Subject</th>
              <th>State</th>
              <th>Assignee</th>
              <th>Last Action</th>
              <th>Comments</th>
              <th>Time</th>
              <th colspan="4" ></th>
            </tr>
          </head>
          <tbody>
          <% @urgent.each do |ticket| %>
            <tr>
              <td><%= ticket.id %></td>
              <td><%=ticket.subject %></td>
              <td><%=ticket.state %></td>
              <td><%= @users.find(ticket.user_id).name %>&nbsp;<%= @users.find(ticket.user_id).last_name %></td>
              <td>
                <% if ticket.comments.try(:any?) %>
                  <%= time_ago_in_words(ticket.comments.maximum('updated_at')) %>
                <% else %>
                  <%= time_ago_in_words(ticket.updated_at) %>
                <% end %>
              </td>
              <td><%= ticket.comments.count %></td>
              <td>
                <%= ticket.timelogs.sum(:spend_time)%> / 
                <%= ticket.estimated_hours %>
              </td>
              <td><%= link_to "<i class='fa fa-arrow-right'></i>".html_safe, change_project_ticket_path(@project, ticket, state: "in progres" ), method: :put %></td>
              <td><%= link_to "<i class='fa fa-eye'></i>".html_safe, project_ticket_path(@project,ticket) %></td>
               
              <td><%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_project_ticket_path(@project, ticket) %></td>
              <td><%= link_to "<i class='fa fa-times'></i>".html_safe, project_ticket_path(@project,ticket), method: :delete, data: { confirm: 'Are you sure?' } %></td>
            </tr>
          <% end %>
          </tbody>
        </table>
        <%end %>
      </div>
    </div>
  </div>
</div>